use deimos::vm::op_codes::{add_mov_int, add_platform_call_to};
use deimos::vm::DmVirtualMachine;
use deimos::vm::dvm_value::DvmValue;

fn main() {
    // TODO:
    // - write a single module with a main() fn which takes cli args
    // - call the main fn
    
    let mut code: Vec<u8> = Vec::new();
    add_mov_int(&mut code, 0, 0x2a); // 42
    add_platform_call_to(
        &mut code,
        &String::from("std::core::println"),
        0,
        1,
        &vec![0u8],
    );
    let mut vm = DmVirtualMachine::new(Vec::new());
    vm.run_raw(&mut code);
    vm.call_by_fqn("default::main", vec![DvmValue::Unit; 0]); // will throw
}
